#ifndef _RECORDACTION_H_
#define _RECORDACTION_H_
#include "oaiaction.h"

#include <map>

#include "comtypes.h"

#include "metaformat.h"

class recordaction : public oaiaction
{
 private:
  metaformat_map formatMap;
  FilterResponse_t gsdlResponse;
  
 public:
  recordaction();
  ~recordaction();
  
  virtual bool validateAction(recptproto *protocol, oaiargs &params);
  bool output_content(ostream &output, recptproto *protocol, oaiargs &params);
  bool output_record(ostream &output, const text_t &collection, const text_t &OID, 
		     const text_t &metadataPrefix);
  bool output_record(ostream &output, recptproto *protocol, const text_t &collection, const text_t &OID, 
		     const text_t &metadataPrefix);
  metaformat_map *get_formats() { return &this->formatMap; }
};
#endif
